/****************************************************************************
**
** Copyright (C) 2016 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of Qt for Python.
**
** $QT_BEGIN_LICENSE:LGPL$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 3 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL3 included in the
** packaging of this file. Please review the following information to
** ensure the GNU Lesser General Public License version 3 requirements
** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 2.0 or (at your option) the GNU General
** Public license version 3 or any later version approved by the KDE Free
** Qt Foundation. The licenses are as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
** included in the packaging of this file. Please review the following
** information to ensure the GNU General Public License requirements will
** be met: https://www.gnu.org/licenses/gpl-2.0.html and
** https://www.gnu.org/licenses/gpl-3.0.html.
**
** $QT_END_LICENSE$
**
****************************************************************************/

//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QDebug>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <pysideqenum.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED

#include <typeinfo>
#include <iterator>

// module include
#include "pyside6_qtbluetooth_python.h"

// main header
#include "qlowenergyadvertisingdata_wrapper.h"

// inner classes

// Extra includes
#include <QList>
#include <QtBluetooth/qbluetoothuuid.h>
#include <QtBluetooth/qlowenergyadvertisingdata.h>
#include <qbytearray.h>


#include <cctype>
#include <cstring>



template <class T>
static const char *typeNameOf(const T &t)
{
    const char *typeName =  typeid(t).name();
    auto size = std::strlen(typeName);
#if defined(Q_CC_MSVC) // MSVC: "class QPaintDevice * __ptr64"
    if (auto lastStar = strchr(typeName, '*')) {
        // MSVC: "class QPaintDevice * __ptr64"
        while (*--lastStar == ' ') {
        }
        size = lastStar - typeName + 1;
    }
#else // g++, Clang: "QPaintDevice *" -> "P12QPaintDevice"
    if (size > 2 && typeName[0] == 'P' && std::isdigit(typeName[1])) {
        ++typeName;
        --size;
    }
#endif
    char *result = new char[size + 1];
    result[size] = '\0';
    memcpy(result, typeName, size);
    return result;
}


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QLowEnergyAdvertisingData_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SbkObject *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QLowEnergyAdvertisingData >()))
        return -1;

    ::QLowEnergyAdvertisingData *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.__init__";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QLowEnergyAdvertisingData", 0, 1, &(pyArgs[0])))
        return -1;


    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingData::QLowEnergyAdvertisingData()
    // 1: QLowEnergyAdvertisingData::QLowEnergyAdvertisingData(QLowEnergyAdvertisingData)
    if (numArgs == 0) {
        overloadId = 0; // QLowEnergyAdvertisingData()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], (pyArgs[0])))) {
        overloadId = 1; // QLowEnergyAdvertisingData(QLowEnergyAdvertisingData)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QLowEnergyAdvertisingData_Init_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // QLowEnergyAdvertisingData()
        {

            if (!PyErr_Occurred()) {
                // QLowEnergyAdvertisingData()
                cptr = new ::QLowEnergyAdvertisingData();
            }
            break;
        }
        case 1: // QLowEnergyAdvertisingData(const QLowEnergyAdvertisingData & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QLowEnergyAdvertisingData cppArg0_local;
            ::QLowEnergyAdvertisingData *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (!PyErr_Occurred()) {
                // QLowEnergyAdvertisingData(QLowEnergyAdvertisingData)
                cptr = new ::QLowEnergyAdvertisingData(*cppArg0);
            }
            break;
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QLowEnergyAdvertisingData >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QLowEnergyAdvertisingData_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QLowEnergyAdvertisingData_Init_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        return -1;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_discoverability(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.discoverability";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // discoverability()const
            QLowEnergyAdvertisingData::Discoverability cppResult = const_cast<const ::QLowEnergyAdvertisingData *>(cppSelf)->discoverability();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_DISCOVERABILITY_IDX]))->converter, &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_includePowerLevel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.includePowerLevel";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // includePowerLevel()const
            bool cppResult = const_cast<const ::QLowEnergyAdvertisingData *>(cppSelf)->includePowerLevel();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_invalidManufacturerId(PyObject *self)
{
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.invalidManufacturerId";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // invalidManufacturerId()
            quint16 cppResult = ::QLowEnergyAdvertisingData::invalidManufacturerId();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_localName(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.localName";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // localName()const
            QString cppResult = const_cast<const ::QLowEnergyAdvertisingData *>(cppSelf)->localName();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_manufacturerData(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.manufacturerData";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // manufacturerData()const
            QByteArray cppResult = const_cast<const ::QLowEnergyAdvertisingData *>(cppSelf)->manufacturerData();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_manufacturerId(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.manufacturerId";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // manufacturerId()const
            quint16 cppResult = const_cast<const ::QLowEnergyAdvertisingData *>(cppSelf)->manufacturerId();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_rawData(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.rawData";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // rawData()const
            QByteArray cppResult = const_cast<const ::QLowEnergyAdvertisingData *>(cppSelf)->rawData();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_services(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.services";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // services()const
            QList<QBluetoothUuid > cppResult = const_cast<const ::QLowEnergyAdvertisingData *>(cppSelf)->services();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtBluetoothTypeConverters[SBK_QTBLUETOOTH_QLIST_QBLUETOOTHUUID_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_setDiscoverability(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setDiscoverability";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingData::setDiscoverability(QLowEnergyAdvertisingData::Discoverability)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_DISCOVERABILITY_IDX]))->converter, (pyArg)))) {
        overloadId = 0; // setDiscoverability(QLowEnergyAdvertisingData::Discoverability)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QLowEnergyAdvertisingDataFunc_setDiscoverability_TypeError;

    // Call function/method
    {
        ::QLowEnergyAdvertisingData::Discoverability cppArg0{QLowEnergyAdvertisingData::DiscoverabilityNone};
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setDiscoverability(QLowEnergyAdvertisingData::Discoverability)
            cppSelf->setDiscoverability(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QLowEnergyAdvertisingDataFunc_setDiscoverability_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_setIncludePowerLevel(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setIncludePowerLevel";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingData::setIncludePowerLevel(bool)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setIncludePowerLevel(bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QLowEnergyAdvertisingDataFunc_setIncludePowerLevel_TypeError;

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setIncludePowerLevel(bool)
            cppSelf->setIncludePowerLevel(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QLowEnergyAdvertisingDataFunc_setIncludePowerLevel_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_setLocalName(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setLocalName";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingData::setLocalName(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // setLocalName(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QLowEnergyAdvertisingDataFunc_setLocalName_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setLocalName(QString)
            cppSelf->setLocalName(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QLowEnergyAdvertisingDataFunc_setLocalName_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_setManufacturerData(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setManufacturerData";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "setManufacturerData", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingData::setManufacturerData(quint16,QByteArray)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], (pyArgs[1])))) {
        overloadId = 0; // setManufacturerData(quint16,QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QLowEnergyAdvertisingDataFunc_setManufacturerData_TypeError;

    // Call function/method
    {
        quint16 cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        if (!Shiboken::Object::isValid(pyArgs[1]))
            return {};
        ::QByteArray cppArg1_local;
        ::QByteArray *cppArg1 = &cppArg1_local;
        if (pythonToCpp[1].isValue())
            pythonToCpp[1](pyArgs[1], &cppArg1_local);
        else
            pythonToCpp[1](pyArgs[1], &cppArg1);


        if (!PyErr_Occurred()) {
            // setManufacturerData(quint16,QByteArray)
            cppSelf->setManufacturerData(cppArg0, *cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QLowEnergyAdvertisingDataFunc_setManufacturerData_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_setRawData(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setRawData";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingData::setRawData(QByteArray)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], (pyArg)))) {
        overloadId = 0; // setRawData(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QLowEnergyAdvertisingDataFunc_setRawData_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QByteArray cppArg0_local;
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (!PyErr_Occurred()) {
            // setRawData(QByteArray)
            cppSelf->setRawData(*cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QLowEnergyAdvertisingDataFunc_setRawData_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_setServices(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setServices";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingData::setServices(QList<QBluetoothUuid>)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtBluetoothTypeConverters[SBK_QTBLUETOOTH_QLIST_QBLUETOOTHUUID_IDX], (pyArg)))) {
        overloadId = 0; // setServices(QList<QBluetoothUuid>)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QLowEnergyAdvertisingDataFunc_setServices_TypeError;

    // Call function/method
    {
        ::QList<QBluetoothUuid > cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setServices(QList<QBluetoothUuid>)
            cppSelf->setServices(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QLowEnergyAdvertisingDataFunc_setServices_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QLowEnergyAdvertisingDataFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyAdvertisingData.swap";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingData::swap(QLowEnergyAdvertisingData&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], (pyArg)))) {
        overloadId = 0; // swap(QLowEnergyAdvertisingData&)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QLowEnergyAdvertisingDataFunc_swap_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QLowEnergyAdvertisingData cppArg0_local;
        ::QLowEnergyAdvertisingData *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (!PyErr_Occurred()) {
            // swap(QLowEnergyAdvertisingData&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QLowEnergyAdvertisingDataFunc_swap_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QLowEnergyAdvertisingData___copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], &cppSelf);
    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QLowEnergyAdvertisingData_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QLowEnergyAdvertisingData_methods[] = {
    {"discoverability", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_discoverability), METH_NOARGS},
    {"includePowerLevel", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_includePowerLevel), METH_NOARGS},
    {"invalidManufacturerId", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_invalidManufacturerId), METH_NOARGS|METH_STATIC},
    {"localName", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_localName), METH_NOARGS},
    {"manufacturerData", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_manufacturerData), METH_NOARGS},
    {"manufacturerId", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_manufacturerId), METH_NOARGS},
    {"rawData", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_rawData), METH_NOARGS},
    {"services", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_services), METH_NOARGS},
    {"setDiscoverability", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_setDiscoverability), METH_O},
    {"setIncludePowerLevel", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_setIncludePowerLevel), METH_O},
    {"setLocalName", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_setLocalName), METH_O},
    {"setManufacturerData", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_setManufacturerData), METH_VARARGS},
    {"setRawData", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_setRawData), METH_O},
    {"setServices", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_setServices), METH_O},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingDataFunc_swap), METH_O},

    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingData___copy__), METH_NOARGS},
    {nullptr, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QLowEnergyAdvertisingData_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], (pyArg)))) {
                // operator!=(const QLowEnergyAdvertisingData & b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QLowEnergyAdvertisingData cppArg0_local;
                ::QLowEnergyAdvertisingData *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf !=(*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], (pyArg)))) {
                // operator==(const QLowEnergyAdvertisingData & b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QLowEnergyAdvertisingData cppArg0_local;
                ::QLowEnergyAdvertisingData *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf ==(*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
            goto Sbk_QLowEnergyAdvertisingData_RichComparison_TypeError;
    }

    if (pyResult && !PyErr_Occurred())
        return pyResult;
    Sbk_QLowEnergyAdvertisingData_RichComparison_TypeError:
    PyErr_SetString(PyExc_NotImplementedError, "operator not implemented.");
    return {};

}

} // extern "C"

static int Sbk_QLowEnergyAdvertisingData_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_QLowEnergyAdvertisingData_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QLowEnergyAdvertisingData_Type = nullptr;
static PyTypeObject *Sbk_QLowEnergyAdvertisingData_TypeF(void)
{
    return _Sbk_QLowEnergyAdvertisingData_Type;
}

static PyType_Slot Sbk_QLowEnergyAdvertisingData_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        nullptr},
    {Py_tp_hash,        nullptr},
    {Py_tp_call,        nullptr},
    {Py_tp_str,         nullptr},
    {Py_tp_getattro,    nullptr},
    {Py_tp_setattro,    nullptr},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingData_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingData_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingData_richcompare)},
    {Py_tp_iter,        nullptr},
    {Py_tp_iternext,    nullptr},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingData_methods)},
    {Py_tp_getset,      nullptr},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingData_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObjectTpNew)},
    {0, nullptr}
};
static PyType_Spec Sbk_QLowEnergyAdvertisingData_spec = {
    "2:PySide6.QtBluetooth.QLowEnergyAdvertisingData",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QLowEnergyAdvertisingData_slots
};

} //extern "C"


// Type conversion functions.

// Python to C++ enum conversion.
static void QLowEnergyAdvertisingData_Discoverability_PythonToCpp_QLowEnergyAdvertisingData_Discoverability(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QLowEnergyAdvertisingData::Discoverability *>(cppOut) =
        static_cast<::QLowEnergyAdvertisingData::Discoverability>(Shiboken::Enum::getValue(pyIn));

}
static PythonToCppFunc is_QLowEnergyAdvertisingData_Discoverability_PythonToCpp_QLowEnergyAdvertisingData_Discoverability_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_DISCOVERABILITY_IDX]))
        return QLowEnergyAdvertisingData_Discoverability_PythonToCpp_QLowEnergyAdvertisingData_Discoverability;
    return {};
}
static PyObject *QLowEnergyAdvertisingData_Discoverability_CppToPython_QLowEnergyAdvertisingData_Discoverability(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QLowEnergyAdvertisingData::Discoverability *>(cppIn));
    return Shiboken::Enum::newItem(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_DISCOVERABILITY_IDX], castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QLowEnergyAdvertisingData_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, reinterpret_cast<PyTypeObject *>(Sbk_QLowEnergyAdvertisingData_TypeF())))
        return QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QLowEnergyAdvertisingData_PTR_CppToPython_QLowEnergyAdvertisingData(const void *cppIn)
{
    auto pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto tCppIn = reinterpret_cast<const ::QLowEnergyAdvertisingData *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = typeNameOf(tCppIn);
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QLowEnergyAdvertisingData_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QLowEnergyAdvertisingData_COPY_CppToPython_QLowEnergyAdvertisingData(const void *cppIn)
{
    return Shiboken::Object::newObject(Sbk_QLowEnergyAdvertisingData_TypeF(), new ::QLowEnergyAdvertisingData(*reinterpret_cast<const ::QLowEnergyAdvertisingData *>(cppIn)), true, true);
}

// Python to C++ copy conversion.
static void QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QLowEnergyAdvertisingData *>(cppOut) = *reinterpret_cast< ::QLowEnergyAdvertisingData *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX], reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, reinterpret_cast<PyTypeObject *>(Sbk_QLowEnergyAdvertisingData_TypeF())))
        return QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QLowEnergyAdvertisingData_SignatureStrings[] = {
    "1:PySide6.QtBluetooth.QLowEnergyAdvertisingData(self)",
    "0:PySide6.QtBluetooth.QLowEnergyAdvertisingData(self,other:PySide6.QtBluetooth.QLowEnergyAdvertisingData)",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.discoverability(self)->PySide6.QtBluetooth.QLowEnergyAdvertisingData.Discoverability",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.includePowerLevel(self)->bool",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.invalidManufacturerId()->quint16",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.localName(self)->QString",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.manufacturerData(self)->PySide6.QtCore.QByteArray",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.manufacturerId(self)->quint16",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.rawData(self)->PySide6.QtCore.QByteArray",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.services(self)->QList[PySide6.QtBluetooth.QBluetoothUuid]",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setDiscoverability(self,mode:PySide6.QtBluetooth.QLowEnergyAdvertisingData.Discoverability)",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setIncludePowerLevel(self,doInclude:bool)",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setLocalName(self,name:QString)",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setManufacturerData(self,id:quint16,data:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setRawData(self,data:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.setServices(self,services:QList[PySide6.QtBluetooth.QBluetoothUuid])",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.swap(self,other:PySide6.QtBluetooth.QLowEnergyAdvertisingData)",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingData.__copy__()",
    nullptr}; // Sentinel

void init_QLowEnergyAdvertisingData(PyObject *module)
{
    _Sbk_QLowEnergyAdvertisingData_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QLowEnergyAdvertisingData",
        "QLowEnergyAdvertisingData",
        &Sbk_QLowEnergyAdvertisingData_spec,
        &Shiboken::callCppDestructor< ::QLowEnergyAdvertisingData >,
        0,
        0,
        0);
    auto *pyType = Sbk_QLowEnergyAdvertisingData_TypeF(); // references _Sbk_QLowEnergyAdvertisingData_Type
    InitSignatureStrings(pyType, QLowEnergyAdvertisingData_SignatureStrings);
    SbkObjectType_SetPropertyStrings(reinterpret_cast<PyTypeObject *>(_Sbk_QLowEnergyAdvertisingData_Type), Sbk_QLowEnergyAdvertisingData_PropertyStrings);
    SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_IDX]
        = Sbk_QLowEnergyAdvertisingData_TypeF();

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(Sbk_QLowEnergyAdvertisingData_TypeF(),
        QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_PTR,
        is_QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_PTR_Convertible,
        QLowEnergyAdvertisingData_PTR_CppToPython_QLowEnergyAdvertisingData,
        QLowEnergyAdvertisingData_COPY_CppToPython_QLowEnergyAdvertisingData);

    Shiboken::Conversions::registerConverterName(converter, "QLowEnergyAdvertisingData");
    Shiboken::Conversions::registerConverterName(converter, "QLowEnergyAdvertisingData*");
    Shiboken::Conversions::registerConverterName(converter, "QLowEnergyAdvertisingData&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QLowEnergyAdvertisingData).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_COPY,
        is_QLowEnergyAdvertisingData_PythonToCpp_QLowEnergyAdvertisingData_COPY_Convertible);

    // Initialization of enums.

    // Initialization of enum 'Discoverability'.
    SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_DISCOVERABILITY_IDX] = Shiboken::Enum::createScopedEnum(Sbk_QLowEnergyAdvertisingData_TypeF(),
        "Discoverability",
        "2:PySide6.QtBluetooth.QLowEnergyAdvertisingData.Discoverability",
        "QLowEnergyAdvertisingData::Discoverability");
    if (!SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_DISCOVERABILITY_IDX])
        return;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_DISCOVERABILITY_IDX],
        Sbk_QLowEnergyAdvertisingData_TypeF(), "DiscoverabilityNone", (long) QLowEnergyAdvertisingData::Discoverability::DiscoverabilityNone))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_DISCOVERABILITY_IDX],
        Sbk_QLowEnergyAdvertisingData_TypeF(), "DiscoverabilityLimited", (long) QLowEnergyAdvertisingData::Discoverability::DiscoverabilityLimited))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_DISCOVERABILITY_IDX],
        Sbk_QLowEnergyAdvertisingData_TypeF(), "DiscoverabilityGeneral", (long) QLowEnergyAdvertisingData::Discoverability::DiscoverabilityGeneral))
        return;
    // Register converter for enum 'QLowEnergyAdvertisingData::Discoverability'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_DISCOVERABILITY_IDX],
            QLowEnergyAdvertisingData_Discoverability_CppToPython_QLowEnergyAdvertisingData_Discoverability);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QLowEnergyAdvertisingData_Discoverability_PythonToCpp_QLowEnergyAdvertisingData_Discoverability,
            is_QLowEnergyAdvertisingData_Discoverability_PythonToCpp_QLowEnergyAdvertisingData_Discoverability_Convertible);
        Shiboken::Enum::setTypeConverter(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYADVERTISINGDATA_DISCOVERABILITY_IDX], converter, false);
        Shiboken::Conversions::registerConverterName(converter, "QLowEnergyAdvertisingData::Discoverability");
        Shiboken::Conversions::registerConverterName(converter, "Discoverability");
    }
    // End of 'Discoverability' enum.

    qRegisterMetaType< ::QLowEnergyAdvertisingData >("QLowEnergyAdvertisingData");
    qRegisterMetaType< ::QLowEnergyAdvertisingData::Discoverability >("QLowEnergyAdvertisingData::Discoverability");
}
